### Signal

# Gtk Application::restore-state

unstable since: 4.24

#### Declaration

    gboolean
    restore_state (
      GtkApplication* self,
      GtkRestoreReason reason,
      GVariant* state,
      gpointer user_data
    )

#### Description [src]

Emitted when application global state is restored.

The handler for this signal should do the opposite of what the corresponding handler for `GtkApplication::save-state` does.

You must be careful to be robust in the face of app upgrades and downgrades: the `state` might have been created by a previous or occasionally even a future version of your app. Do not assume that a given key exists in the state. Apps must try to restore state saved by a previous version, but are free to discard state if it was written by a future version.

Default handler: The default handler is called after the handlers added via `g_signal_connect()`.
Available since: 4.24

#### Parameters

`reason`

  Type: `GtkRestoreReason`

  The reason for restoring state.

`state`

  Type: `GVariant`

  An `a{sv}` dictionary containing the state to restore, as saved by a `GtkApplication::save-state` handler.

  The data is owned by the caller of the function.

#### Return value

Type: `gboolean`

True to stop further handlers from running.